<script setup>
import MMap from '@/components/map/MMap.vue'
import MSourceRasterDem from '@/components/sources/MSourceRasterDem.vue'
import MSourceGeojson from '@/components/sources/MSourceGeojson.vue'

import MLayerHillshade from '@/components/layers/MLayerHillshade.vue'
import MLayerFill from '@/components/layers/MLayerFill.vue'
import MLayerCircle from '@/components/layers/MLayerCircle.vue'

import MControlTerrain from '@/components/controls/MControlTerrain.vue'
import MControlScale from '@/components/controls/MControlScale.vue'
import MControlFullscreen from '@/components/controls/MControlFullscreen.vue'
import MControlNavigation from '@/components/controls/MControlNavigation.vue'
import MControlAttribution from '@/components/controls/MControlAttribution.vue'

const geojson = {
  type: 'FeatureCollection',
  features: [
    {
      type: 'Feature',
      geometry: {
        type: 'Polygon',
        coordinates: [
          [
            [-121.353637, 40.584978],
            [-121.284551, 40.584758],
            [-121.275349, 40.541646],
            [-121.246768, 40.541017],
            [-121.251343, 40.423383],
            [-121.32687, 40.423768],
            [-121.360619, 40.43479],
            [-121.363694, 40.409124],
            [-121.439713, 40.409197],
            [-121.439711, 40.423791],
            [-121.572133, 40.423548],
            [-121.577415, 40.550766],
            [-121.539486, 40.558107],
            [-121.520284, 40.572459],
            [-121.487219, 40.550822],
            [-121.446951, 40.56319],
            [-121.370644, 40.563267],
            [-121.353637, 40.584978]
          ]
        ]
      }
    },
    {
      type: 'Feature',
      geometry: {
        type: 'Point',
        coordinates: [-121.415061, 40.506229]
      }
    },
    {
      type: 'Feature',
      geometry: {
        type: 'Point',
        coordinates: [-121.505184, 40.488084]
      }
    },
    {
      type: 'Feature',
      geometry: {
        type: 'Point',
        coordinates: [-121.354465, 40.488737]
      }
    }
  ]
}

const mounted = l => {
  console.log(l)
}
</script>

<template>
  <m-map
    tiles="https://api.maptiler.com/maps/streets/style.json?key=get_your_own_OpIi9ZULNHzrESv6T2vL"
    :center="[-121.403732, 40.492393]"
    :zoom="10">

    <m-source-raster-dem
      id="hills"
      url="https://demotiles.maplibre.org/terrain-tiles/tiles.json"
      :tileSize="256" />

    <m-control-attribution
      compact
      position="top-left" />

    <m-control-navigation />
    <m-control-fullscreen />
    <m-control-terrain
      source="hills" />

    <m-control-scale
      position="bottom-left" />

    <m-source-geojson
      :data="geojson">

      <m-layer-circle
        id="points"
        :filter="['==', '$type', 'Point']"
        :radius="6"
        color="#B42222" />

      <m-layer-fill
        @mounted="mounted"
        before="points"
        :filter="['==', '$type', 'Polygon']"
        color="#888888"
        :opacity="0.4" />

    </m-source-geojson>

  </m-map>
</template>
